unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, system.Math, Vcl.ExtDlgs, Vcl.ExtCtrls, System.UIConsts,
  Vcl.StdCtrls, System.UITypes, Vcl.Imaging.GIFImg;

type
  TForm1 = class(TForm)
    FileOpenBtn: TButton;
    ScrollBox1: TScrollBox;
    ScrollBox2: TScrollBox;
    Image1: TImage;
    Image2: TImage;
    OpenPictureDialog1: TOpenPictureDialog;
    RGBtoHSLbtn: TButton;
    RadioGroup1: TRadioGroup;
    SavePictureDialog1: TSavePictureDialog;
    FileSaveBtn: TButton;
    LabeledEdit1: TLabeledEdit;
    LabeledEdit2: TLabeledEdit;
    LabeledEdit3: TLabeledEdit;
    ColorControlBtn: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FileOpenBtnClick(Sender: TObject);
    procedure RGBtoHSLbtnClick(Sender: TObject);
    procedure FileSaveBtnClick(Sender: TObject);
    procedure ColorControlBtnClick(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

type
  TAlphaarry = array[0..0] of TAlphaColor;    // TAlphaColorz
  PAlphaarray = ^TAlphaarry;                  // z̃|C^[

const
// t@Cgqݒ
  OpenFileFilter =
    '摜t@C|*.png;*.jpg;*.gif;*.bmp;*.tif;*.ico;*.wdp'+
    '|*.png|*.png' +
    '|*.jpg|*.jpg' +
    '|*.gif|*.gif' +
    '|*.bmp|*.bmp' +
    '|*.tif|*.tif' +
    '|*.ico|*.ico' +
    '|*.wdp|*.wdp';

  SaveFileFilter =
    '摜t@C|*.png;*.jpg;*.gif;*.bmp;*.tif;*.wdp' +
    '|*.png|*.png' +
    '|*.jpg|*.jpg' +
    '|*.gif|*.gif' +
    '|*.bmp|*.bmp' +
    '|*.tif|*.tif' +
    '|*.wdp|*.wdp';

var
  InBitmap        : TBitmap;                    // rbg}bv
  OutBitmap       : TBitmap;
  GHeight, GWidth : integer;                    // \[X摜TCY

//=================================================================
// RGB  HSL ϊ \
// H 0`1(0`360)  S -X`X  L 0`1    L ̒l 0.5F 0 ͍ 1 ͔
//=================================================================
procedure TForm1.RGBtoHSLbtnClick(Sender: TObject);
var
  i, j        : integer;
  D           : Byte;
  hf, Sf, Lf  : single;
  pb          : PRGBQuadArray;                                // Vcl.Imaging.GIFImg
  pbi         : PAlphaarray;
  CAlpha      : TAlphaColor;
begin
  for i := 0 to Gheight - 1 do begin
    pbi := Inbitmap.ScanLine[i];
    pb  := OutBitmap.ScanLine[i];
    D   := 0;
    for j := 0 to GWidth - 1 do begin
      CAlpha := pbi[j];                                       // TAlphaColor̎擾
      RGBtoHSL(CAlpha, Hf, Sf, lf);                           // HSL ϊ
      case RadioGroup1.ItemIndex of                           // WI{^̈ʒuŕ\ύX
        0 : D := Round(Hf * 255);                             // F
        1 : D := Round(Sf * 255);                             // ʓx
        2 : D := Round(Lf * 255);                             // x
      end;
      pb[j].rgbBlue       := D;                               // OFlZbgăO[
      pb[j].rgbGreen      := D;
      pb[j].rgbRed        := D;
      pb[j].rgbReserved   := 0;                               // tOȂ
    end;
  end;
  image2.Picture.Bitmap := OutBitmap;                         // 摜\
end;

//======================================================
// ColorConrol
// H S L ꂼ̌WŕύX R G B ɕϊĉ摜\
//======================================================
procedure TForm1.ColorControlBtnClick(Sender: TObject);
var
  Hue, sat, Lvalue  : Single;
  k                 : integer;
  Hi, sati          : Single;
  Lvaluei           : Single;
  X, Y              : Integer;
  Pb                : PAlphaarray;
  pbi               : PAlphaarray;
begin
  val(LabeledEdit1.Text, Hue, K);
  if K <> 0 then begin
    Application.MessageBox('Fpx̓͒lɌ肪܂B','F',0);
    exit;
  end;
  if abs(hue) > 360 then begin
    Application.MessageBox('Fpxl傫܂B','F',0);
    exit;
  end;
  val(LabeledEdit2.Text, sat, K);
  if K <> 0 then begin
    Application.MessageBox('ʓxGainW̓͒lɌ肪܂B','ʓx',0);
    exit;
  end;
  val(LabeledEdit3.Text, Lvalue, K);
  if K <> 0 then begin
    Application.MessageBox('xGainW̓͒lɌ肪܂B','x',0);
    exit;
  end;
  if Lvalue < 0 then begin
    Application.MessageBox('xGainW̓[ȉł͂܂B','x',0);
    exit;
  end;
  for Y := 0 to GHeight - 1 do begin
    pbi := Inbitmap.ScanLine[Y];
    pb  := OutBitmap.ScanLine[Y];
    for X := 0 to GWidth - 1 do begin
      RGBtoHSL(pbi[X], Hi, Sati, LValuei);                // HSL ϊ
      Hi := Hi + Hue / 360;                               // F̏
      if Hi < 0   then Hi := Hi + 1;
      if Hi > 1 then Hi := Hi - 1;
      sati := sati * sat;                                 // ʓx̏
      if sati > 1 then sati := 1;
      Lvaluei := Lvaluei * Lvalue;                        // x̏
      if Lvaluei > 1 then Lvaluei := 1;
      pb[X] := HSLtoRGB(Hi, sati, Lvaluei);               // H S L  R G B ɕϊ
{ ChangeHSLgpꍇ́Aω^܂A
  xɑ΂ẮAω傫ӂKvłB
@HSLtoRGBgpقǂ悤łB}
//      pb[X] := ChangeHSL(pb[X], Hue / 360, sat, Lvalue);
    end;
  end;
  image2.Picture.Bitmap := OutBitmap;                         // 摜\
  FileSaveBtn.Enabled := True;
end;

//========================================
// t@C̎wI[v
// I[v摜\
//========================================
procedure TForm1.FileOpenBtnClick(Sender: TObject);
var
  WIC         : TWICImage;
  InFilename  : String;
begin
  OpenPictureDialog1.Filter := OpenFileFilter;                // t@CI[vtB^[̐ݒ
  if OpenPictureDialog1.Execute then                          // t@Cw肳ꂽ
    begin
      WIC := TWICImage.Create;                                // TWICImage̐
      try
        InFilename := OpenPictureDialog1.FileName;            // t@C̎擾
        WIC.LoadFromFile(InFilename);                         // 摜̓ǂݍ
        GHeight := WIC.Height;                                // 摜擾
        GWidth  := WIC.Width;                                 // 摜
        InBitmap.Width    := GWidth;                          // 摜
        InBitmap.Height   := GHeight;                         // 摜
        InBitmap.Canvas.Draw(0, 0, WIC);                      // DrawInBitmapɓ͉摜ݒtH[}bg32rbgɕϊ܂
        OutBitmap.Width   := GWidth;                          // o͉摜
        OutBitmap.Height  := GHeight;                         // o͉摜
        image1.Picture.Bitmap := InBitmap;                    // 摜\
      finally
        WIC.Free;                                             // TWICImage 
      end;
    end
    else Exit;
  RGBtoHSLbtn.Enabled := True;                                // {^Cl[u
  ColorControlBtn.Enabled := True;
end;

//=============================
// t@C֕ۑ
//=============================
procedure TForm1.FileSaveBtnClick(Sender: TObject);
var
  WIC     : TWicImage;
  WICF    : TWicImageFormat;

  Fname   : String;
  ExeStr  : String;
  FnameTop: String;
  Findex  : integer;

  function WFormatSet: Boolean;                                             // gqɂt@CtH[}bgݒ
  begin
    Result := false;
    ExeStr := LowerCase(ExeStr);
    if ExeStr = '.jpg'  then  begin WICF := Wifjpeg; Result := True; end;
    if ExeStr = '.jpeg' then  begin WICF := Wifjpeg; Result := True; end;
    if ExeStr = '.tif'  then  begin WICF := Wiftiff; Result := True; end;
    if ExeStr = '.tiff' then  begin WICF := Wiftiff; Result := True; end;
    if ExeStr = '.png'  then  begin WICF := Wifpng;  Result := True; end;
    if ExeStr = '.gif'  then  begin WICF := Wifgif;  Result := True; end;
    if ExeStr = '.bmp'  then  begin WICF := Wifbmp;  Result := True; end;
    if ExeStr = '.wdp'  then  begin WICF := WifWMPhoto; Result := True; end;
    if ExeStr = '.hdp'  then  begin WICF := WifWMPhoto; Result := True; end;
  end;

begin
  SavePictureDialog1.Filter := SaveFileFilter;
//  SavePictureDialog1.DefaultExt := GraphicExtension(TWicImage);
  if not SavePictureDialog1.Execute then exit;
  ExeStr := ExtractFileExt(SavePictureDialog1.FileName);
  if ExeStr = '' then begin                                                 // gqȂ
    Findex := SavePictureDialog1.FilterIndex;                               // FilterIndexɂgq̐ݒ
    case Findex of
      1, 3 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.jpg');    // gq̐ݒ
         2 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.png');
         4 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.gif');
         5 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.bmp');
         6 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.tif');
         7 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.wdp');
    end;
  end
  else
    Fname := SavePictureDialog1.FileName;
  ExeStr := ExtractFileExt(Fname);                                          // gqo
  if not WFormatSet then begin                                              // gqɂt@CtH[}bgݒƊmF
    application.MessageBox('t@C̊gqԈĂ܂B','', 0);
    exit;
  end;
  FnameTop := ExtractFileName(Fname);                                       // t@Co
  if Length(FnameTop) = Length(ExeStr) then begin                           // t@C̒mF
    application.MessageBox('t@C܂B','', 0);
    exit;
  end;

  if FileExists(Fname) then                                                 // t@Cɂt@C
    if MessageDlg('ɓÕt@C܂㏑܂ ' + ExtractFileName(Fname) + '?',
                                                      mtConfirmation, [mbYes, mbNo], 0, mbNo) = IDNo then exit;

  WIC := TWicImage.Create;                                                  // TWicImage
  try
    WIC.Assign(OutBitmap);                                                  // TWicImageɃrbg}bvf[^[t
    WIC.ImageFormat := WICF;                                                // ۑtH[}bgZbg
    WIC.SaveTofile(Fname);                                                  // t@C̏o
  finally                                                                   // XE3,XE4̏ꍇ̓AV[v}XLOQƂĂ
    WIC.Free;                                                               // TWicImage
  end;
end;

//============
// ݒ
//============
procedure TForm1.FormCreate(Sender: TObject);
begin
  Top := (Screen.Height - Height) div 2;                      // \ʒuݒ
  Left := (Screen.Width - Width) div 2;
  InBitmap      := TBitmap.Create;                            // ͉摜p
  OutBitmap     := TBitmap.Create;                            // o͉摜p
  InBitmap.PixelFormat    := pf32bit;                         // 32rbgJ[ɐݒ
  OutBitmap.PixelFormat   := pf32bit;                         // 32rbgJ[ɐݒ
  RGBtoHSLbtn.Enabled := False;                               // {^fBXGu
  FileSaveBtn.Enabled := False;
  ColorControlBtn.Enabled := False;
end;

//=============================
// Irbg}bv̉
//=============================
procedure TForm1.FormDestroy(Sender: TObject);
begin
  InBitmap.Free;
  OutBitmap.Free;
end;

end.
